import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { provideRouter } from '@angular/router';
import { provideHttpClient } from '@angular/common/http';
import {
  GoogleLoginProvider,
  SocialAuthServiceConfig,
} from '@abacritt/angularx-social-login';

import { routes } from './app.routes';

export const appConfig: ApplicationConfig = {
  providers: [
    provideZoneChangeDetection({ eventCoalescing: true }),
    provideRouter(routes),
    provideHttpClient(),
     // olio, jossa on sosiaalisen loginin konfiguraatio:
     {
      provide: 'SocialAuthServiceConfig',
      useValue: {
        autoLogin: false,
        providers: [
          {
            id: GoogleLoginProvider.PROVIDER_ID,
            // Googlen client-id
            provider: new GoogleLoginProvider(
              'laita_oma_google_client_id_tunnus_tähän.apps.googleusercontent.com'
            ),
          },
        ],
      } as SocialAuthServiceConfig,
    },// sosiaalisen loginin konfiguraatio loppuu
  ],
};
